﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Item : MonoBehaviour {

	[SerializeField]
	private ItemManager manager;
	[SerializeField]
	RectTransform pos;
	[SerializeField]
	public int type;
	[SerializeField]
	private Image img;
	[SerializeField]
	public Animator myAnim;

	[SerializeField]
	private List<Sprite> itemtypes;

	public int checkPoint;

	public void Spawn(Vector2 newPos, int newType){
		pos.anchoredPosition = newPos;
		type = newType;
		SetUp ();
	}

	public void SetUp(){
		img.sprite = itemtypes [type];
	}

	public void MoveBox(Vector2 newPos){
		StartCoroutine (Move (newPos));
	}

	IEnumerator Move(Vector2 newPos){
		Vector2 moveInc = newPos - pos.anchoredPosition;
//		print ("moving");
//		print (moveInc.x + ";" + moveInc.y);
//		print (newPos.x + ";" + newPos.y);
		for(int i=0;i<7;i++){
//			print (pos.anchoredPosition.x + ";" + pos.anchoredPosition.y);
			pos.anchoredPosition = new Vector2 (pos.anchoredPosition.x + moveInc.x / 7, pos.anchoredPosition.y + moveInc.y / 7);
			yield return new WaitForSeconds (0.01f);
		}
		if (checkPoint > 5) {
			manager.PoolItem (this);
		} else {
			checkPoint++;
		}
		yield return 0;
	}

	public void checkItem(){
		print ("itemstatus:" + img.sprite + "; " + pos.anchoredPosition.x + "," + pos.anchoredPosition.y + "type" + type);
	}
}
