﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class ItemManager : MonoBehaviour {

	[SerializeField]
	public Manager manager;
	[SerializeField]
	private List<RectTransform> checkPoints;
	[SerializeField]
	private List<Item> activeItems;
	[SerializeField]
	private List<Item> passiveItems;

	int count;

	public void Start(){
		count = 0;
		RandomItem ();
	}

	void RandomItem(){
		for(int i=0;i<activeItems.Count;i++){
			print ("random");
			activeItems [i].type = Random.Range (0, 3);
			activeItems [i].SetUp ();
		}
	}

	public Item LastItem(int itemcount){
		return activeItems [itemcount];
	}

	public void Spawn(){
		if (activeItems.Count < 7) {
			passiveItems[0].checkPoint = 2;
			passiveItems [0].gameObject.SetActive (true);
			int type = Random.Range (0, 3);
			passiveItems [0].Spawn (checkPoints [0].anchoredPosition, type);
			activeItems.Add (passiveItems [0]);
			passiveItems.RemoveAt (0);
		}
	}

	public void PoolItem(Item item){
		item.gameObject.SetActive (false);
		passiveItems.Add (item);
		activeItems.Remove (item);
	}

	public void EnterBox(string direction){
		activeItems[0].checkItem();
		Spawn ();
		count++;
		print ("count: " + count);
		print (direction);
		int box = 0;
		if (direction == "up") {
			manager.PlayDestroySFX ();
			//rejected go to checkpoint 9
			activeItems[0].MoveBox(checkPoints[8].anchoredPosition);
		} else if (direction == "down") {
			//move to checkpoint 8
			activeItems[0].MoveBox(checkPoints[9].anchoredPosition);
			box = 2;
		}else if (direction == "right") {
			//move to to checkpoint 7
			activeItems[0].MoveBox(checkPoints[6].anchoredPosition);
			box = 1;
		}else if (direction == "left") {
			//move to checkpoint 6
			activeItems[0].MoveBox(checkPoints[7].anchoredPosition);
			box = 0;
		}
		if (direction != "up") {
			if (activeItems [0].type == manager.boxes.activeBoxes [box].type) {
				Player.combo++;
				manager.PlayRightSFX ();
				manager.boxes.activeBoxes [box].PlayAnim ();
				print ("correct");
				manager.boxes.activeBoxes [0].Match ();
				if(Player.combo>9){
					manager.ui.MultiOn ();
				}
			} else {
				Player.combo = 1;
				print ("wrong");
				manager.ui.Penalty ();
				manager.PlayWrongSFX ();
				if (Player.life > 1) {
					Player.life--;
				}
				if(Player.life<=1) {
					print ("game over");
					manager.isGameOver = true;
				}
			}
		}
		NextItem ();
	}

	void NextItem(){
		for(int i=1;i<5;i++){
			activeItems [i].MoveBox (checkPoints[6-i].anchoredPosition);
		//	activeItems [i].checkPoint = 7 - i;
		}
	}
		
	public void RightBox(){
		Player.box++;
		Player.score += 100;
	}
	public void WrongBox(){
		Player.score -= 100;
		Player.life--;
		if (Player.life <= 0) {
		
		}
	}
}
