﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Manager : MonoBehaviour {

	[SerializeField]
	public UI ui;
	[SerializeField]
	public ItemManager items;
	[SerializeField]
	public BoxManager boxes;

	public bool isGameOver;

	[SerializeField]
	private AudioClip bgm;
	[SerializeField]
	private AudioClip destroy;
	[SerializeField]
	private AudioClip right;
	[SerializeField]
	private AudioClip wrong;

	// Use this for initialization
	void Start () {
		Player.Init ();
		SoundManager.instance.playBGMLoop (bgm);
		isGameOver = false;
		Player.life = Player.maxLife;
		Player.time = Player.maxTime;
		StartCoroutine (CountDown ());
	}

	public void PlayRightSFX(){
		SoundManager.instance.playSFXOnce (right);
	}

	public void PlayWrongSFX(){
		SoundManager.instance.playSFXOnce (wrong);
	}

	public void PlayDestroySFX(){
		SoundManager.instance.playSFXOnce (destroy);
	}

	IEnumerator CountDown(){
		if (Player.maxTime > 30f) {
			Player.time = Player.maxTime;
		} else {
			Player.time = 30f;
		}
		while (!isGameOver&&Player.time>0f) {
			Player.time -= Time.deltaTime;
			if (Player.time < 15f&&Player.time>14.5f) {
				ui.TimeUp ();
			}
			yield return new WaitForSeconds (0.01f);
			ui.SetUp ();
		}
		isGameOver = true;
		SceneChanges.Change ("Ending");
		yield return 0;
	}

}
