﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class UI : MonoBehaviour {

	[SerializeField]
	private Manager manager;
	[SerializeField]
	private Text scoreText;
	[SerializeField]
	private Text timeText;
	[SerializeField]
	private Text comboText;

	[SerializeField]
	private Image multiImg;
	[SerializeField]
	private Image multiBar;

	[SerializeField]
	private List<Sprite> combos;
	[SerializeField]
	private List<Sprite> combosBar;

	[SerializeField]
	private Image focus;

	[SerializeField]
	private Image hurry;

	[SerializeField]
	private Image penalty;

	public void SetUp(){
		scoreText.text = Player.score.ToString ();
		if (Player.time > 0f) {
			timeText.text = Mathf.CeilToInt (Player.time*100).ToString ();
		} else {
			timeText.text = "0";
		}
		comboText.text = Player.combo.ToString ();
		if (multiImg != null) {
			if (multiBar.fillAmount <= 0f && multiImg.gameObject.activeInHierarchy) {
				multiImg.gameObject.SetActive (false);
			}
			if (Player.time < 15f) {
				hurry.gameObject.SetActive (true);
			}
		}
	}

	public void Penalty(){
	//	StartCoroutine (PenaltyOn ());
		penalty.gameObject.SetActive(true);
	}

	public void MultiOn(){
		if (!multiImg.gameObject.activeInHierarchy) {
			multiImg.gameObject.SetActive (true);
		} else {
			if(Player.combo>10){
				focus.gameObject.SetActive (false);
				if (Player.combo < 20) {
					multiBar.sprite = combosBar [0];
					multiImg.sprite = combos [0];
				} else if (Player.combo < 30) {
					multiBar.sprite = combosBar [1];
					multiImg.sprite = combos [1];
				} else if (Player.combo < 40) {
					multiBar.sprite = combosBar [2];
					multiImg.sprite = combos [2];
				} else if (Player.combo < 50) {
					multiBar.sprite = combosBar [3];
					multiImg.sprite = combos [3];
				} else {
					multiBar.sprite = combosBar [4];
					multiImg.sprite = combos [4];
					hurry.gameObject.SetActive (true);
				}
				multiBar.gameObject.SetActive (true);
				StopAllCoroutines ();
				StartCoroutine (DecreaseComboMeter ());
			}
		}
	}
	public IEnumerator DecreaseComboMeter(){
		multiImg.gameObject.SetActive (true);
		multiBar.fillAmount = 1f;
		print ("combo on");
		while(multiBar.fillAmount>0f){
			multiBar.fillAmount -= (float)Time.deltaTime * (Player.combo)*0.01f;
			yield return new WaitForSeconds (0.01f);
		}
		yield return 0;
	}
	public void TimeUp(){
		if(!hurry.gameObject.activeInHierarchy)
			hurry.gameObject.SetActive (true);
	}

	IEnumerator PenaltyOn(){
		penalty.gameObject.SetActive (true);
		while(penalty.color.a>0.1f){
			penalty.color = new Color (penalty.color.r, penalty.color.g, penalty.color.b, penalty.color.a - Time.deltaTime/3);
			yield return new WaitForSeconds (0.01f);
		}
		penalty.gameObject.SetActive (false);
		yield return 0;
	}
		
}
